package cc.smtweb.framework.auth.captcha;

import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

public class ImageMaker {
  private static final String signChar = "()+-*/=";

  //  生成png图片
  public void make() throws IOException {
    int fontHeight = 34;
    int width = 19;
    int height = fontHeight * (62 + signChar.length());
    // 创建BufferedImage对象

    BufferedImage image = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
    // ---------- 增加下面的代码使得背景透明 -----------------
    Graphics2D g2d = image.createGraphics();
    image = g2d.getDeviceConfiguration().createCompatibleImage(width, height, Transparency.TRANSLUCENT);
    g2d.dispose();

    // 画图
    g2d = image.createGraphics();
    g2d.setColor(new Color(0,0,0));

    // 画图
    Font font = new Font("Courier New", Font.BOLD, 30);
    g2d.setFont(font);

    System.out.println(font.getMaxCharBounds(g2d.getFontRenderContext()));

    int top = 25;
    for (int i = 0; i < 10; i++) {
      g2d.drawString(i + "", 0, top);
      top += fontHeight;
    }

    for (int i = 0; i < 26; i++) {
      g2d.drawString((char)(i + (int)'a') + "", 0, top);
      top += fontHeight;
    }

    for (int i = 0; i < 26; i++) {
      g2d.drawString((char)(i + (int)'A') + "", 0, top);
      top += fontHeight;
    }

    for (int i = 0; i < signChar.length(); i++) {
      g2d.drawString(signChar.charAt(i) + "", 0, top);
      top += fontHeight;
    }

    // 释放对象
    g2d.dispose();

    // 保存文件
    ImageIO.write(image, "png", new File("/var/tmp/test.png"));
  }

  public static void main(String[] args) throws IOException {
    new ImageMaker().make();
  }
}
