package cc.smtweb.framework.auth.spring.cache;

import cc.smtweb.framework.core.annotation.SwCache;
import cc.smtweb.framework.core.cache.AbstractCache;
import cc.smtweb.framework.core.db.jdbc.JdbcEngine;
import cc.smtweb.framework.core.mvc.realm.service.PermChecker;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.*;

/**
 * 用户权限集合缓存器，@todo 权限部分需要重写
 * @author xkliu
 */
@Log4j2
@SwCache(ident = "PERM_CHECKER", title = "用户权限")
public class RealmCache extends AbstractCache<PermChecker> {
    @Autowired
    private JdbcEngine dbEngine;

    private static final long ENTERPRISE_ADMIN_ID = 1;

    @Override
    protected String getId(PermChecker bean) {
        return "1";//todo
    }

    @Override
    protected List<PermChecker> loadAll() {
        return null;
    }


    protected PermChecker load(Long key) {
        // admin
        if (key == ENTERPRISE_ADMIN_ID) {
            return PermChecker.build(new HashSet<>(Collections.singletonList("*")));
        }

        // TODO: 合并相同角色，自己到缓存里面获取
        Set<String> permissions = new HashSet<>();

        List<String> permList = dbEngine.queryStringList("SELECT menu_api_perm FROM sys_menu WHERE menu_id in\n" +
                "(SELECT rmp_menu_id from sys_role_menu_privilege WHERE rmp_role_id in\n" +
                "(SELECT role_id FROM sw_user.sys_role WHERE role_id IN" +
                "(SELECT ur_role_id FROM sw_user.sys_user_role WHERE ur_user_id=?)))", key);

        if (permList != null) {
            for (String perm: permList) {
                for (String item: perm.split(",")) {
                    permissions.add(item.trim());
                }
            }
        }

        return PermChecker.build(permissions);
    }

}
