package cc.smtweb.framework.core.common;

import lombok.Data;

/**
 * Created by Akmm at 2022/3/23 9:39
 * 系统的一些枚举变量
 */
public interface SwEnum {

    /**
     * Created by Akmm at 2022/2/9 10:01
     * 字段业务类别
     */
    class FieldType extends IntEnum{
        public static FieldType instance = new FieldType();

        public static IntEnumBean ID = instance.addEnum(1, "主键");
        public static IntEnumBean CODE = instance.addEnum(2, "编码字段");
        public static IntEnumBean NAME = instance.addEnum(3, "名称字段");
        public static IntEnumBean PARENT_ID = instance.addEnum(4, "父ID");
        public static IntEnumBean LEVEL_CODE = instance.addEnum(5, "级次码");
        public static IntEnumBean ORDER = instance.addEnum(6, "排序字段");
        public static IntEnumBean CREATE_USER = instance.addEnum(7, "创建人");
        public static IntEnumBean CREATE_TIME = instance.addEnum(8, "创建时间");
        public static IntEnumBean UPDATE_USER = instance.addEnum(9, "更新人");
        public static IntEnumBean LAST_TIME = instance.addEnum(10, "更新时间");
    }

    /**
     * 数据类型定义，参见design_db.yaml配置
     */
    @Data
    class DataType {
      /*{type: "id", name: "ID", sql-type: "bigint", java-type: "long", widget: "fz-field-long", defaultValue: "0"}
        - {type: "code", name: "编码", sql-type: "varchar", java-type: "string", data-length: 32, widget: "fz-field-string", defaultValue: ""}
        - {type: "name", name: "名字", sql-type: "varchar", java-type: "string", data-length: 100, widget: "fz-field-string", defaultValue: ""}
        - {type: "remark", name: "备注", sql-type: "varchar", data-length: 255, java-type: "string", widget: "fz-field-string", defaultValue: ""}
        - {type: "text", name: "大文本", sql-type: "text", java-type: "string", widget: "fz-field-string", defaultValue: ""}
        - {type: "currency", name: "货币", sql-type: "bigint", java-type: "long", widget: "fz-field-long", defaultValue: "0"}
        - {type: "datetime", name: "时间日期", sql-type: "bigint", java-type: "long", widget: "fz-field-datetime", defaultValue: "0"}
        - {type: "date", name: "日期", sql-type: "int", java-type: "int", widget: "fz-field-date", defaultValue: "0"}
        - {type: "time", name: "时间", sql-type: "int", java-type: "int", widget: "fz-field-time", defaultValue: "0"}
        - {type: "int", name: "整型", sql-type: "int", java-type: "int", widget: "fz-field-int", defaultValue: "0"}
        - {type: "smallint", name: "短整型", sql-type: "smallint", java-type: "short", widget: "fz-field-int", defaultValue: "0"}
        - {type: "bool", name: "布尔型", sql-type: "tinyint", java-type: "boolean", widget: "fz-field-bool", defaultValue: "0"}*/
      public static final String TYPE_STR = "varchar";
      public static final String TYPE_BOOL = "bool";
      public static final String TYPE_DATETIME = "datetime";
      public static final String TYPE_DATE = "date";

      private String type;
      private String name;
      private String sqlType;
      private int dataLength;
      private String javaType;
      private String defaultValue;
    }

    /**
     * 表类型
     */
    class TableType extends IntEnum {
        public static TableType instance = new TableType();

        public static AbstractEnum.IntEnumBean TYPE_GENERAL = instance.addEnum(0, "普通表");
        public static AbstractEnum.IntEnumBean TYPE_TREE = instance.addEnum(1, "树型表");
        public static AbstractEnum.IntEnumBean TYPE_CODE = instance.addEnum(2, "编码表");
        public static AbstractEnum.IntEnumBean TYPE_ABSTACT = instance.addEnum(3, "虚拟抽象表");
        public static AbstractEnum.IntEnumBean TYPE_VIEW = instance.addEnum(4, "视图");

    }
}
