package cc.smtweb.framework.core.db.cache;

import cc.smtweb.framework.core.annotation.SwCache;
import cc.smtweb.framework.core.cache.AbstractCache;
import cc.smtweb.framework.core.cache.CacheManager;
import cc.smtweb.framework.core.db.DbEngine;
import cc.smtweb.framework.core.db.EntityDao;
import cc.smtweb.framework.core.db.vo.ModelDatabase;

import java.util.List;

/**
 * Created by Akmm at 2022/1/12 18:34
 */
@SwCache(ident = "ASP_MODEL_DATABASE", title = "数据库")
public class ModelDatabaseCache extends AbstractCache<ModelDatabase> {
    private final static String mk = "k";

    public static ModelDatabaseCache getInstance() {
        return CacheManager.getIntance().getCache(ModelDatabaseCache.class);
    }

    public ModelDatabaseCache() {
        regMap(mk, ModelDatabase::getName);
    }

    @Override
    protected String getId(ModelDatabase bean) {
        return String.valueOf(bean.getId());
    }

    @Override
    protected List<ModelDatabase> loadAll() {
        EntityDao<ModelDatabase> dao = DbEngine.getInstance().findDao(ModelDatabase.class);
        return dao.query();
    }

    public final ModelDatabase getByName(String key) {
        return getByKey(mk, key);
    }
}
