package cc.smtweb.framework.core.mvc.realm.interceptor;

import cc.smtweb.framework.core.annotation.SwPerm;
import cc.smtweb.framework.core.redis.RedisManager;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.HandlerInterceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 暂时未使用，spring的拦截器方式判断权限
 */
public class AuthorizationInterceptor extends AbstractPermInterceptor implements HandlerInterceptor {

  public AuthorizationInterceptor(RedisManager redisManager) {
    super(redisManager);
  }

  @Override
  public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler)
          throws Exception {
    if (handler instanceof HandlerMethod) {
      HandlerMethod handlerMethod = (HandlerMethod) handler;
      // 获取方法上的注解
      SwPerm requiredSwPerm = handlerMethod.getMethod().getAnnotation(SwPerm.class);
      // 如果方法上的注解为空 则获取类的注解
      if (requiredSwPerm == null) {
        requiredSwPerm = handlerMethod.getMethod().getDeclaringClass().getAnnotation(SwPerm.class);
      }

      String requiredValue = null;
      if (requiredSwPerm != null) {
        requiredValue = requiredSwPerm.value();
      }

      return super.handle(request, requiredValue);
    }

    return true;
  }
}
