package cc.smtweb.framework.core.mvc.service;

import cc.smtweb.framework.core.R;
import cc.smtweb.framework.core.SwMap;
import cc.smtweb.framework.core.db.DbEngine;
import cc.smtweb.framework.core.session.UserSession;
import lombok.extern.slf4j.Slf4j;

/**
 * Created by Akmm at 2022/3/2 19:44
 * 保存
 */
@Slf4j
public abstract class AbstractDelHandler<T> extends AbstractHandler<T>{
    protected long id;

    @Override
    public R doWork() throws Exception {
        id = readId();

        checkValid();
        DbEngine.getInstance().doTrans(() -> {
            try {
                del();
                saveSuccess();
                return true;
            } catch (Exception e) {
                saveFailed();
                log.error("保存失败！", e);
                return false;
            }
        });
        return R.success();
    }

    /**
     * 读取页面传回来的id
     * @return
     */
    protected long readId() {
        return params.readLong("id", 0L);
    }

    protected abstract void checkValid() throws Exception;
    protected abstract void del() throws Exception;
    protected void saveSuccess() {}
    protected void saveFailed() {}
}
