package cc.smtweb.framework.core.mvc.service;

import cc.smtweb.framework.core.common.SwEnum;
import cc.smtweb.framework.core.db.DbEngine;
import cc.smtweb.framework.core.db.EntityDao;
import cc.smtweb.framework.core.db.cache.ModelTableCache;
import cc.smtweb.framework.core.db.impl.DefaultEntity;
import cc.smtweb.framework.core.db.vo.ModelField;
import cc.smtweb.framework.core.db.vo.ModelTable;

/**
 * Created by Akmm at 2022/3/2 19:52
 * 默认实体实现
 */
public class DefaultLoadHandler<T extends DefaultEntity> extends AbstractLoadHandler<T> {
    protected String tableName;

    public DefaultLoadHandler(String tableName) {
        this.tableName = tableName;
    }

    @Override
    protected T createComp() throws Exception {
        final EntityDao<T> dao = DbEngine.getInstance().findDao(tableName);
        T bean = dao.createBean();
        ModelTable table = ModelTableCache.getInstance().getByName(tableName);
        ModelField field = table.findFieldByType(SwEnum.FieldType.CREATE_USER.value);
        if (field != null) bean.put(field.getName(), us.getUserId());
        return bean;
    }

    @Override
    protected T loadComp(long id) {
        return new DefaultProvider<T>(tableName).getBean(id);
    }
}
