package cc.smtweb.system.bpm.core.exception;

import lombok.Getter;

@Getter
public class ModelLoaderError {
  public static final int ERROR_FLOW = 11;
  public static final int ERROR_NODE = 12;
  public static final int ERROR_ACTION = 13;
  public static final int ERROR_CONNECTION = 14;
  public static final int ERROR_DB = 21;
  public static final int ERROR_TABLE = 22;
  public static final int ERROR_FIELD = 23;
  public static final int ERROR_INDEX = 24;
  public static final int ERROR_UI = 31;
  public static final int ERROR_UI_DATASET = 32;

  private int type;
  private final String id;
  private final String subId;
  private String msg;

  public ModelLoaderError(int type, String msg) {
    this(type, null, null,  msg);
  }

  public ModelLoaderError(int type, String id, String msg) {
    this(type, id, null, msg);
  }

  public ModelLoaderError(int type, String id, String subId, String msg) {
    this.type = type;
    this.id = id;
    this.subId = subId;
    this.msg = msg;
  }

  @Override
  public String toString() {
    if (id != null) {
      return msg;
    } else {
      return "[id=" + id + "]"+ msg;
    }
  }
}
