package cc.smtweb.system.bpm.core.ui.dataset;

import cc.smtweb.system.bpm.core.ui.entity.dataset.BpmField;
import org.apache.commons.lang3.StringUtils;

/**
 * 字段格式化工具
 *
 * @author xkliu
 */
public class FieldFormatTool {
    public static boolean needFormat(BpmField bpmField) {
        return StringUtils.isNotBlank(bpmField.getDisplayFormat());
    }

    public static FieldFormatter buildFormatter(BpmField bpmField) {

        switch (bpmField.getType()) {
            case BpmField.TYPE_DATE:
                return new DateFieldFormater(bpmField.getName());
            case BpmField.TYPE_DATE_TIME:
                return new DateTimeFieldFormater(bpmField.getName());
            default:
                return new FieldFormatter(bpmField.getName());
        }
    }

    public static void fixDisplayFormat(BpmField bpmField) {
        if (StringUtils.isBlank(bpmField.getDisplayFormat())) {
            switch (bpmField.getType()) {
                case BpmField.TYPE_DATE:
                    bpmField.setDisplayFormat("yyyy-MM-dd");
                    break;
                case BpmField.TYPE_DATE_TIME:
                    bpmField.setDisplayFormat("yyyy-MM-dd HH:mm:ss");
                    break;
                default:
                    break;
            }
        }
    }
}
