package cc.smtweb.system.bpm.core.ui.entity;

import cc.smtweb.system.bpm.core.ui.entity.dataset.BpmDataset;
import cc.smtweb.system.bpm.core.ui.entity.form.BpmForm;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@Data
public class BpmPage implements Serializable {
  private long id;
  private String fullName;
  private int modelType;
  private boolean isDeploy = true;
  private Boolean destroyOnClose;
  // 数据集
  private List<BpmDataset> datasets = new ArrayList<>();
  // 界面
  private List<BpmForm> forms = new ArrayList<>();

  public BpmDataset findDatasetByName(String name) {
    if (StringUtils.isNotBlank(name)) {
      for (BpmDataset dataset : datasets) {
        if (name.equals(dataset.getName())) {
          return dataset;
        }
      }
    }

    return null;
  }

  public BpmDataset findMasterDataset() {
    return datasets.get(0);
  }

  public void addDataset(BpmDataset dataset) {
    datasets.add(dataset);
  }
}
