package cc.smtweb.system.bpm.core.ui.entity.dataset;

import cc.smtweb.system.bpm.engine.ui.entity.consts.MappingTypeEnum;
import lombok.Getter;

public abstract class AbstractBpmFieldLookup {
  @Getter
  private final String db;

  @Getter
  private final String table;

  @Getter
  private final boolean number;

  /**
   * lookup对象类型
   * @return Lookup对象类型
   */
  public abstract int type();

  public AbstractBpmFieldLookup(String dbName, String table, boolean isNumber) {
    this.db = dbName;
    this.table = table;
    this.number = isNumber;
  }

  public abstract MappingTypeEnum getMappingType();

  public boolean isManyToMany() {
    return MappingTypeEnum.manyToMany.equals(getMappingType());
  }
}
