package cc.smtweb.system.bpm.core.ui.entity.dataset;

import cc.smtweb.system.bpm.engine.ui.entity.consts.MappingTypeEnum;
import lombok.Data;

@Data
public class BpmField {
  public static final String TYPE_DATE = "date";
  public static final String TYPE_DATE_TIME = "datetime";
//  /** ID */
//  public static final int REF_TYPE_ID = 1;
//  /** 上级ID */
//  public static final int REF_TYPE_PARENT_ID = 2;
//  /** CODE编码 */
//  public static final int REF_TYPE_CODE = 3;
//  /** 显示顺序 */
//  public static final int REF_TYPE_ORDER = 11;
//  /** 标题字段 */
//  public static final int REF_TYPE_TITLE = 21;
//  /** 描述字段 */
//  public static final int REF_TYPE_REMARK = 22;

  private String id;
  private String name;
  private String label;
  private String fieldName;
  private String type;
  private String summary;
  private boolean required;
  private boolean readonly;
  private String validPatten;
  private String validMessage;
  private int refType;
  private String displayFormat;
  private AbstractBpmFieldLookup lookup;
  private int filter;
  private int filterType;

  public void setLookup(AbstractBpmFieldLookup lookup) {
    this.lookup = lookup;
  }

  // 判断是否多对多字段
  public boolean isLookupManyToMay() {
    if (this.lookup != null) {
      return MappingTypeEnum.manyToMany.equals(this.lookup.getMappingType());
    }

    return false;
  }
}
