package cc.smtweb.system.bpm.core.ui.entity.dataset;

import cc.smtweb.system.bpm.engine.ui.entity.consts.MappingTypeEnum;
import cc.smtweb.system.bpm.engine.ui.entity.consts.UiEnum;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

@Getter @Setter
public class BpmFieldLookup extends AbstractBpmFieldLookup {
//  public static final int TYPE = 1;
  private final MappingTypeEnum mappingType;

  private String keyField;
  private String labelField;
  private String parentField;
  private String orderField;
  private String middleTable;
  private String middleIdField;
  private String middleKeyField;
  private String middleValueField;

  private List<BpmFieldFilter> filters;

  @Override
  public int type() {
    return UiEnum.FieldLookupType.TABLE;
  }

  public BpmFieldLookup(String dbName, String table, boolean isNumber, MappingTypeEnum mappingType) {
    super(dbName, table, isNumber);
    this.mappingType = mappingType;
  }

  public void addFilter(String field, int op, String keyword, boolean cascade) {
    if (filters == null) {
      filters = new ArrayList<>();
    }

    BpmFieldFilter filter = new BpmFieldFilter();
    filter.setField(field);
    filter.setKeyword(keyword);
    filter.setOp(op);
    filter.setCascade(cascade);

    filters.add(filter);
  }
}
