package cc.smtweb.system.bpm.core.ui.entity.dataset;

import cc.smtweb.system.bpm.engine.ui.entity.consts.MappingTypeEnum;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

@Data
public class BpmMasterMapping {
  // 映射到主表的类型 MappingTypeEnum
  private MappingTypeEnum mappingType;
  // 主表表名
  private String master;
  // 中间表名
  private String middle;
  // 映射字段列表
  private List<BpmMappingField> mappingFields;

  public void add(String masterFieldName, String slaveFieldName, String middleFieldName) {
    if (mappingFields == null) {
      mappingFields = new ArrayList<>();
    }

    BpmMappingField linkField = new BpmMappingField();
    linkField.setMaster(masterFieldName);
    linkField.setSlave(slaveFieldName);
    linkField.setMiddle(middleFieldName);

    mappingFields.add(linkField);
  }

  public boolean isOneToOne() {
    return MappingTypeEnum.oneToOne.equals(mappingType);
  }
}
