package cc.smtweb.system.bpm.core.ui.entity.form;

import cc.smtweb.framework.core.SwMap;
import cc.smtweb.system.bpm.engine.ui.entity.vo.widiget.UiControlDataVO;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

import java.util.HashMap;
import java.util.Map;

/**
 * 设计器的控件配置数据
 * @author xkliu
 */
@Data
public class BpmWidget {
  private String type;
  private String name;
  private BpmWidgetLayout layout;
  private SwMap props = new SwMap();
  private Map<String, UiControlDataVO[]> slots;
  private Map<String, String> events;
  /** 前端响应变量，key和value值相同表示要生成前端变量 */
  private Map<String, String> vars;
  /** 子控件列表 */
  private BpmWidget[] children;

  public void addProp(String key, String value) {
    props.put(key, value);
  }

  public void addEvents(Map<String, String> events) {
    if (events != null && !events.isEmpty()) {
      this.events = events;
    }
  }

  public void addProps(Map<String, Object> props) {
    this.props.putAll(props);
  }

  public void addVars(Map<String, String> vars) {
    if (vars != null && !vars.isEmpty()) {
      for (Map.Entry<String, String> entry: vars.entrySet()) {
        String key = entry.getKey();
        String value = entry.getValue();

        if (StringUtils.isNotBlank(value)) {
          if (this.vars == null) {
            this.vars = new HashMap<>(vars.size());
          }

          this.vars.put(key, value);
        }
      }
    }
  }

  public void addSlots(Map<String, UiControlDataVO[]> slots) {
    if (slots != null && !slots.isEmpty()) {
      this.slots = new HashMap<>(slots.size());
      slots.forEach((k, v) -> {
        if (v.length > 0) {
          this.slots.put(k, v);
        }
      });

      if (this.slots.isEmpty()) {
        this.slots = null;
      }
    } else {
      this.slots = null;
    }
  }
}
