package cc.smtweb.system.bpm.core.ui.service;

import cc.smtweb.framework.core.mvc.controller.access.IMethodAccess;
import cc.smtweb.system.bpm.core.exception.BpmException;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;

/**
 * Bpm事件执行器,执行@BpmEvent注解的函数
 * @author xkliu
 */
public class DatasetApiInvoker {
  private IMethodAccess methodAccess;

  public DatasetApiInvoker(IMethodAccess methodAccess) {
    this.methodAccess = methodAccess;
  }

  public Object invoke(BpmPageContext pageContext) {
    try {
      // TODO 检测返回值
      return methodAccess.invoke(pageContext.getContext(), pageContext.getParams(), pageContext.getPostBody(), pageContext.getRequest());
    } catch (Exception e) {
      throw new BpmException(e);
    }
  }

  public Object invoke(BpmPageContext pageContext, Object bean) {
    try {
      // TODO bean放入上下文
      return methodAccess.invoke(pageContext.getContext(), pageContext.getParams(), pageContext.getPostBody(), pageContext.getRequest());
    } catch (Exception e) {
      throw new BpmException(e);
    }
  }

  public Class<?> getReturnType() {
    return methodAccess.getReturnType();
  }

  public Class<?> getBodyType() {
    return methodAccess.getBodyType();
  }

  public Class<?> getAttrType(String paramName) {
    return methodAccess.getAttrType(paramName);
  }
}
