package cc.smtweb.system.bpm.core.ui.service.card.agent;

import cc.smtweb.framework.core.SwMap;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.service.AbstractDatasetAgent;
import cc.smtweb.system.bpm.core.ui.service.DatasetApiInvoker;
import lombok.Setter;

import java.util.function.Function;

/**
 * Card数据集读取执行代理，调用@BpmEvent的事件
 * @author xkliu
 */
public class DatasetLoadAgent extends AbstractDatasetAgent {
  @Setter
  private DatasetApiInvoker beforeLoad;
  @Setter
  private DatasetApiInvoker afterLoad;
  @Setter
  private DatasetApiInvoker load;
  private final Function<BpmPageContext, SwMap> defaultLoadFunc;

  public DatasetLoadAgent(Function<BpmPageContext, SwMap> loadFunc) {
    this.defaultLoadFunc = loadFunc;
  }

  public SwMap doLoad(BpmPageContext pageContext) {
    // bean 处理
    if (beforeLoad != null) {
      beforeLoad.invoke(pageContext);
    }

    if (this.load != null) {
      Object bean = this.load.invoke(pageContext);
      saveAttrRow(pageContext, bean);
    } else {
      SwMap body = this.defaultLoadFunc.apply(pageContext);
      saveAttrRowMap(pageContext, body);
    }

    if (afterLoad != null) {
      afterLoad.invoke(pageContext);
    }

    return loadAttrRowMap(pageContext);
  }
}
