package cc.smtweb.system.bpm.core.ui.service.list;

import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.bind.IBpmBeanConst;
import cc.smtweb.system.bpm.core.ui.service.DatasetApiInvoker;
import cc.smtweb.system.bpm.core.ui.service.list.agent.DatasetCountAgent;
import cc.smtweb.system.bpm.core.ui.service.list.agent.DatasetListAgent;

public class DatasetListAgentWorker extends DatasetListWorker {
  private DatasetListAgent listAllAgent;
  private DatasetListAgent listPartAgent;
  private DatasetCountAgent countAgent;

  public DatasetListAgentWorker(BpmPageContext pageContext) {
    super(pageContext);
  }

  private DatasetListAgent loadListAllAgent(Class<?> clazz) {
    if (listAllAgent == null) {
      listAllAgent = new DatasetListAgent(listAllFunc);
      this.handleListAll(listAllAgent::doList);
    }

    listAllAgent.checkType(clazz);

    return listAllAgent;
  }

  private DatasetListAgent loadListPartAgent(Class<?> clazz) {
    if (listPartAgent == null) {
      listPartAgent = new DatasetListAgent(listFunc);
      this.handleListPart(listPartAgent::doList);
    }

    listPartAgent.checkType(clazz);

    return listPartAgent;
  }

  private DatasetCountAgent loadCountAgent(Class<?> clazz) {
    if (countAgent == null) {
      countAgent = new DatasetCountAgent(countFunc);
      this.handleCount(countAgent::doCount);
    }

    countAgent.checkType(clazz);
    return countAgent;
  }

  public void onBeforeList(DatasetApiInvoker beforeFunc) {
    loadListAllAgent(beforeFunc.getAttrType(IBpmBeanConst.ATTRIBUTE_ROWS)).setBeforeList(beforeFunc);
    loadListPartAgent(beforeFunc.getAttrType(IBpmBeanConst.ATTRIBUTE_ROWS)).setBeforeList(beforeFunc);
  }

  public void onListAll(DatasetApiInvoker listAllFunc) {
    loadListAllAgent(listAllFunc.getAttrType(IBpmBeanConst.ATTRIBUTE_ROWS)).setList(listAllFunc);
  }

  public void onAfterList(DatasetApiInvoker afterFunc) {
    loadListAllAgent(afterFunc.getAttrType(IBpmBeanConst.ATTRIBUTE_ROWS)).setAfterList(afterFunc);
    loadListPartAgent(afterFunc.getAttrType(IBpmBeanConst.ATTRIBUTE_ROWS)).setAfterList(afterFunc);
  }

  public void onListPart(DatasetApiInvoker listFunc) {
    loadListPartAgent(listFunc.getAttrType(IBpmBeanConst.ATTRIBUTE_ROWS)).setList(listFunc);
  }

  public void onBeforeCount(DatasetApiInvoker beforeFunc) {
    loadCountAgent(null).setBeforeCount(beforeFunc);
  }

  public void onAfterCount(DatasetApiInvoker afterFunc) {
    loadCountAgent(null).setAfterCount(afterFunc);
  }

  public void onCount(DatasetApiInvoker countFunc) {
    loadCountAgent(null).setCount(countFunc);
  }
}
