package cc.smtweb.system.bpm.core.ui.service.list;

import cc.smtweb.framework.core.SwMap;
import cc.smtweb.system.bpm.core.ui.BpmMapData;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.entity.dataset.BpmDataset;
import cc.smtweb.system.bpm.core.ui.entity.dataset.BpmFieldLookup;
import cc.smtweb.system.bpm.core.ui.service.DatasetWorker;

import java.util.List;
import java.util.Set;
import java.util.function.BiFunction;
import java.util.function.Function;

public class DatasetListWorker extends DatasetWorker {
  protected Function<BpmPageContext, List<SwMap>> listFunc;
  protected Function<BpmPageContext, List<SwMap>> listAllFunc;
  protected BiFunction<BpmPageContext, Set<String>, BpmMapData> listLookupFunc;
  protected Function<BpmPageContext, SwMap> countFunc;

  public DatasetListWorker(BpmPageContext body) {
    super(body);
  }

  public void handleListPart(Function<BpmPageContext, List<SwMap>> listFunc) {
    this.listFunc = listFunc;
  }

  public void handleCount(Function<BpmPageContext, SwMap> countFunc) {
    this.countFunc = countFunc;
  }

  public void handleListAll(Function<BpmPageContext, List<SwMap>> listAllFunc) {
    this.listAllFunc = listAllFunc;
  }

  public void handleListLookup(BiFunction<BpmPageContext, Set<String>, BpmMapData> listLookupFunc) {
    this.listLookupFunc = listLookupFunc;
  }

  public List<SwMap> list(BpmDataset dataset) {
    pageContext.setDataset(dataset);
    pageContext.setFieldLookup(null);
    return this.listFunc.apply(pageContext);
  }

  public SwMap count(BpmDataset dataset) {
    pageContext.setDataset(dataset);
    pageContext.setFieldLookup(null);
    return this.countFunc.apply(pageContext);
  }

  public List<SwMap> listAll(BpmDataset dataset, BpmFieldLookup lookup) {
    pageContext.setDataset(dataset);
    pageContext.setFieldLookup(lookup);
    return this.listAllFunc.apply(pageContext);
  }

  public BpmMapData listLookup(BpmDataset dataset, BpmFieldLookup lookup, Set<String> idSet) {
    pageContext.setDataset(dataset);
    pageContext.setFieldLookup(lookup);
    return this.listLookupFunc.apply(pageContext, idSet);
  }
}
