package cc.smtweb.system.bpm.core.ui.service.list.agent;

import cc.smtweb.framework.core.SwMap;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.service.AbstractDatasetAgent;
import cc.smtweb.system.bpm.core.ui.service.DatasetApiInvoker;
import lombok.Setter;

import java.util.List;
import java.util.function.Function;

/**
 * card数据集读取列表方法代理执行，调用@BpmEvent的事件
 * @author xkliu
 */
public class DatasetListAgent extends AbstractDatasetAgent {
  @Setter
  private DatasetApiInvoker beforeList;
  @Setter
  private DatasetApiInvoker list;
  @Setter
  private DatasetApiInvoker afterList;

  private final Function<BpmPageContext, List<SwMap>> defaultListFunc;

  public DatasetListAgent(Function<BpmPageContext, List<SwMap>> listFunc) {
    this.defaultListFunc = listFunc;
  }

  public List<SwMap> doList(BpmPageContext pageContext) {
    // bean 处理
    if (beforeList != null) {
      beforeList.invoke(pageContext);
    }

    if (this.list != null) {
      List<?> beans = (List<?>)this.list.invoke(pageContext);
      saveAttrRows(pageContext, beans);

      if (afterList != null) {
        afterList.invoke(pageContext);
      }
    } else {
      List<SwMap> map = this.defaultListFunc.apply(pageContext);
      saveAttrRowsMap(pageContext, map);

      if (afterList != null) {
        afterList.invoke(pageContext);
      }
    }

    return loadAttrRowsMap(pageContext);
  }
}
