package cc.smtweb.system.bpm.core.ui.service.tree;

import cc.smtweb.framework.core.R;
import cc.smtweb.framework.core.SwMap;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.entity.dataset.BpmDataset;
import cc.smtweb.system.bpm.core.ui.service.AbstractDatasetService;

import java.util.List;

public abstract class AbstractDatasetTreeService extends AbstractDatasetService {
  /**
   * 创建树数据集treeAll处理器
   * @param pageContext 页面上下文参数
   * @return 树数据集处理器
   */
  protected abstract DatasetTreeWorker createTreeAllHandler(BpmPageContext pageContext);
  /**
   * 创建树数据集treeMove处理器
   * @param pageContext 页面上下文参数
   * @return 树数据集处理器
   */
  protected abstract DatasetTreeWorker createTreeMoveHandler(BpmPageContext pageContext);

  public R treeAll(BpmPageContext pageContext) {
    DatasetTreeWorker handler = createTreeAllHandler(pageContext);
//    setupTreeAll(handler);

    List<SwMap> data = handler.treeAll(handler.getDataset());

    return R.success(data);
  }

  public R move(BpmPageContext pageContext) {
    DatasetTreeWorker handler = createTreeMoveHandler(pageContext);
//    setupMove(handler);
    BpmDataset dataset = handler.getDataset();

    handler.move(dataset);

    return null;
  }
}
