package cc.smtweb.system.bpm.core.ui.service.tree;

import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.bind.IBpmBeanConst;
import cc.smtweb.system.bpm.core.ui.service.DatasetApiInvoker;
import cc.smtweb.system.bpm.core.ui.service.tree.agent.DatasetMoveAgent;
import cc.smtweb.system.bpm.core.ui.service.tree.agent.DatasetTreeAllAgent;

public class DatasetTreeAgentWorker extends DatasetTreeWorker {
  private DatasetTreeAllAgent treeAllAgent;
  private DatasetMoveAgent moveAgent;

  public DatasetTreeAgentWorker(BpmPageContext pageContext) {
    super(pageContext);
  }

  private DatasetTreeAllAgent loadTreeAllAgent(Class<?> clazz) {
    if (treeAllAgent == null) {
      treeAllAgent = new DatasetTreeAllAgent(treeAllFunc);
      this.handleTreeAll(treeAllAgent::doTreeAll);
    }

    treeAllAgent.checkType(clazz);
    return treeAllAgent;
  }

  private DatasetMoveAgent loadMoveAgent() {
    if (moveAgent == null) {
      moveAgent = new DatasetMoveAgent(moveFunc);
      this.handleMove(moveAgent::doMove);
    }

    return moveAgent;
  }

  public void onBeforeMove(DatasetApiInvoker func) {
    loadMoveAgent().setBeforeMove(func);
  }

  public void onMove(DatasetApiInvoker func) {
    loadMoveAgent().setMove(func);
  }

  public void onAfterMove(DatasetApiInvoker func) {
    loadMoveAgent().setAfterMove(func);
  }

  public void onBeforeTreeAll(DatasetApiInvoker func) {
    loadTreeAllAgent(null).setBeforeTreeAll(func);
  }

  public <T> void onTreeAll(DatasetApiInvoker func) {
    loadTreeAllAgent(func.getAttrType(IBpmBeanConst.ATTRIBUTE_ROWS)).setTreeAll(func);
  }

  public <T> void onAfterTreeAll(DatasetApiInvoker func) {
    loadTreeAllAgent(func.getAttrType(IBpmBeanConst.ATTRIBUTE_ROWS)).setAfterTreeAll(func);
  }
}
