package cc.smtweb.system.bpm.core.ui.service.tree.agent;

import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.service.DatasetApiInvoker;
import lombok.Setter;

import java.util.function.Function;
/**
 * tree数据集排序方法代理执行，调用@BpmEvent的事件
 * @author xkliu
 */
public class DatasetMoveAgent {
  @Setter
  private DatasetApiInvoker beforeMove;
  @Setter
  private DatasetApiInvoker afterMove;
  @Setter
  private DatasetApiInvoker move;

  private final Function<BpmPageContext, Integer> defaultMoveFunc;

  public DatasetMoveAgent(Function<BpmPageContext, Integer> defaultMoveFunc) {
    this.defaultMoveFunc = defaultMoveFunc;
  }

  public Integer doMove(BpmPageContext pageContext) {
    Integer result = null;

    // bean 处理
    if (beforeMove != null) {
      beforeMove.invoke(pageContext);
    }

    if (this.move != null) {
      result = (Integer)this.move.invoke(pageContext);
    } else {
      result = this.defaultMoveFunc.apply(pageContext);
    }

    if (afterMove != null) {
      afterMove.invoke(pageContext);
    }

    return result;
  }
}
