package cc.smtweb.system.bpm.core.ui.service.tree.agent;

import cc.smtweb.framework.core.SwMap;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.service.AbstractDatasetAgent;
import cc.smtweb.system.bpm.core.ui.service.DatasetApiInvoker;
import lombok.Setter;

import java.util.List;
import java.util.function.Function;
/**
 * tree数据获取全部树方法代理执行，调用@BpmEvent的事件
 * @author xkliu
 */
public class DatasetTreeAllAgent extends AbstractDatasetAgent {
  @Setter
  private DatasetApiInvoker beforeTreeAll;
  @Setter
  private DatasetApiInvoker treeAll;
  @Setter
  private DatasetApiInvoker afterTreeAll;

  private final Function<BpmPageContext, List<SwMap>> defaultTreeAllFunc;

  public DatasetTreeAllAgent(Function<BpmPageContext, List<SwMap>> treePartFunc) {
    this.defaultTreeAllFunc = treePartFunc;
  }

  public List<SwMap> doTreeAll(BpmPageContext pageContext) {
    // bean 处理
    if (beforeTreeAll != null) {
      beforeTreeAll.invoke(pageContext);
    }

    if (this.treeAll != null) {
      List<?> beans = (List<?>)this.treeAll.invoke(pageContext);
      saveAttrRows(pageContext, beans);
    } else {
      List<SwMap> body = this.defaultTreeAllFunc.apply(pageContext);
      saveAttrRowsMap(pageContext, body);
    }

    if (afterTreeAll != null) {
      afterTreeAll.invoke(pageContext);
    }

    return loadAttrRowsMap(pageContext);
  }
}
