package cc.smtweb.system.bpm.engine.entity;

import cc.smtweb.system.bpm.util.ITreeDataLevelHandler;
import lombok.Data;

import java.util.List;

@Data
public class AspModelTreeVO extends AspModelPO {
  private List<AspModelTreeVO> children;
  private int level;

  // 树结构数据句柄
  public static ITreeDataLevelHandler<AspModelTreeVO> createTreeHandler() {
    return new ITreeDataLevelHandler<AspModelTreeVO> () {
      @Override
      public Long getId (AspModelTreeVO node){
        return node.getModelId();
      }

      @Override
      public Long getParentId (AspModelTreeVO node){
        return node.getModelParentId();
      }

      @Override
      public List<AspModelTreeVO> getChildren (AspModelTreeVO node){
        return node.children;
      }

      @Override
      public void setChildren (AspModelTreeVO node, List < AspModelTreeVO > children){
        node.children = children;
      }

      @Override
      public int getLevel (AspModelTreeVO node){
        return node.level;
      }

      @Override
      public void setLevel (AspModelTreeVO node,int level){
        node.level = level;
      }
    } ;
  }
}
