package cc.smtweb.system.bpm.engine.process.runtime;

import org.springframework.expression.ExpressionParser;
import org.springframework.expression.spel.standard.SpelExpressionParser;
import org.springframework.expression.spel.support.StandardEvaluationContext;

/**
 * 条件表达式处理器
 * @author kevin
 */
public class ConditionExpression {
  private ExpressionParser parser = new SpelExpressionParser();
  private StandardEvaluationContext context;

  public ConditionExpression(ProcessContext rootObject) {
    context = new StandardEvaluationContext(rootObject);
  }

  public Object execute(String condition) {
    return parser.parseExpression(condition).getValue(context);
  }

  public <T> T execute(String condition, Class<T> clazz) {
    return parser.parseExpression(condition).getValue(context, clazz);
  }
}
