package cc.smtweb.system.bpm.engine.process.runtime;

import cc.smtweb.system.bpm.engine.process.vo.FlowNode;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

public class ProcessRoute {
  @Getter @Setter
  private FlowNode node;
  @Getter
  private List<ProcessInstance> subList;

  @Getter @Setter
  private ProcessRouteInfo info;

  public void addSubProcess(ProcessInstance process) {
    if (subList == null) {
      subList = new ArrayList<>();
    }

    subList.add(process);
  }

  public ProcessRouteInfo post() {
    if (info == null) {
      info = new ProcessRouteInfo();
      info.setRoutes(new ArrayList<>());
    }

    if (node != null || subList != null) {
      ProcessRouteItem item = new ProcessRouteItem();
      item.setNode(node.getId());

      if (subList != null) {
        List<Long> list = new ArrayList<>();
        for (ProcessInstance pi: subList) {
          list.add(pi.getId());
        }

        item.setSub(list);
        subList = null;
      }

      node = null;
    }

    return info;
  }

  public ProcessRouteItem findRouteByProcess(long processId) {
    if (info != null) {
      List<ProcessRouteItem> routes = info.getRoutes();
      if (routes != null) {
        for (int i = routes.size() - 1; i >= 0; i--) {
          ProcessRouteItem item = routes.get(i);

          if (item.findProcess(processId)) {
            return item;
          }
        }
      }
    }

    return null;
  }

  public ProcessRouteItem returnRoute() {
    if (info != null) {
      List<ProcessRouteItem> routes = info.getRoutes();
      if (routes != null && routes.size() > 0) {
        return routes.remove(routes.size() - 1);
      }
    }

    return null;
  }

  public ProcessRouteItem lastRoute() {
    if (info != null) {
      List<ProcessRouteItem> routes = info.getRoutes();
      if (routes != null && routes.size() > 0) {
        return routes.get(routes.size() - 1);
      }
    }

    return null;
  }
}
