package cc.smtweb.system.bpm.engine.process.runtime;

import cc.smtweb.system.bpm.core.exception.BpmIlegalArgumentException;
import cc.smtweb.system.bpm.engine.process.vo.FlowNode;
import lombok.Getter;

import java.util.ArrayList;
import java.util.List;

@Getter
public class RouteInfo {
  List<Route> routes = new ArrayList<>();

  public void add(ProcessInstance process, FlowNode node) {
    if (routes.size() > 1000) {
      // 避免死循环
      throw new BpmIlegalArgumentException("route count out of range");
    }

    process.setCurNode(node, true);
    routes.add(new Route(process, node));
  }
}
