package cc.smtweb.system.bpm.engine.process.vo;

import cc.smtweb.system.bpm.core.exception.BpmObjectNotFoundException;
import lombok.Data;

import java.io.Serializable;
import java.util.Map;

@Data
public class Flow implements Serializable {
  private Map<String, FlowNode> nodeMap;
  private FlowNode beginNode;
  private FlowTable table;
  private long id;

  public FlowNode findNode(String nodeId) {
    return this.nodeMap.get(nodeId);
  }

  public FlowNode checkAndGetNode(String nodeKey) {
    FlowNode flowNode = findNode(nodeKey);

    if (flowNode == null) {
      throw new BpmObjectNotFoundException("not find node by key: " + nodeKey);
    }

    return flowNode;
  }
}
