package cc.smtweb.system.bpm.engine.process.vo;

import cc.smtweb.system.bpm.core.exception.BpmObjectNotFoundException;
import lombok.Data;

@Data
public class FlowAction {
  public static final int TYPE_COMMIT = 1;
  public static final int TYPE_SAVE = 2;
  public static final int TYPE_RETURN = 3;
  public static final int TYPE_TRANSMIT = 4;
  public static final int TYPE_FINISH = 5;
  public static final int TYPE_REJECT = 6;

  private String id;
  private int type;
  private String label;
  private FlowConnection connection;
  /** 条件表达式 */
  private String expression;

  public FlowConnection checkAndGetConnection() {
    if (connection == null) {
      throw new BpmObjectNotFoundException("未找Action的连接, action_id=" + id);
    }

    return connection;
  }
}
