package cc.smtweb.system.bpm.engine.ui.entity.consts;

import java.util.HashMap;
import java.util.Map;

public class BiMapEnum<K, V> {
  private Map<K, V> normalMap = new HashMap<>();
  private Map<V, K> reverseMap = new HashMap<>();

  public V put(K key, V value) {
    if (key != null && value != null) {
      V result = normalMap.put(key, value);
      reverseMap.put(value, key);

      return result;
    }

    return null;
  }

  public V getValue(K key) {
    return normalMap.get(key);
  }

  public K getKey(V value) {
    return reverseMap.get(value);
  }

  public V remove(K key) {
    V result = normalMap.remove(key);
    if (result != null) {
      reverseMap.remove(result);
    }

    return result;
  }

  public K addEnum(K key, V value) {
    put(key, value);
    return key;
  }

  public static class IntEnum extends BiMapEnum<Integer, String> {}

//  public static class EnumBean<K, V> {
//    public K key;
//    public V value;
//
//    public EnumBean(K key, V value) {
//      this.key = key;
//      this.value = value;
//    }
//  }
}
