package cc.smtweb.system.bpm.engine.ui.entity.consts;

import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

/**
 * 数据集映射关系
 * @author xkliu
 */
@Getter
public enum MappingTypeEnum {
  // none, 1:1, 1:N, N:1, N:N
  none, oneToOne, oneToMany, manyToOne, manyToMany;

  public static int toOrdinal(String name) {
    return toEnum(name).ordinal();
  }

  public static MappingTypeEnum toEnum(String name) {
    if (StringUtils.isNotBlank(name)) {
      return valueOf(name);
    }

    return none;
  }

  public boolean sameOrdinal(int value) {
    return ordinal() == value;
  }

  public boolean sameName(String name) {
    if (StringUtils.isNotBlank(name)) {
      return name().equals(name);
    }

    return this.equals(none);
  }

  public boolean include(MappingTypeEnum ... args) {
    for (MappingTypeEnum arg: args) {
      if (arg.equals(this)) {
        return true;
      }
    }

    return false;
  }
}
