package cc.smtweb.system.bpm.engine.ui.entity.consts;

/**
 * 界面相关枚举，字段作用
 * @author xkliu
 */
public interface UiEnum {
  // 字段作用类型
  class FieldRefType extends BiMapEnum.IntEnum{
    /** 字段作用 */
    public static final int ID = 1;
    public static final int PARENT_ID = 2;
    public static final int CODE = 3;
    public static final int PARENT_ID_LIST = 4;
    public static final int TREE_LEVEL = 5;
    public static final int CREATE_TIME = 6;
    public static final int LAST_TIME = 7;
    public static final int SITE_ID = 8;
//    public static final int USER_ID = 9;
    public static final int ORDER = 11;
    public static final int TITLE = 21;
    public static final int REMARK = 22;

    public static FieldRefType INSTANCE = new FieldRefType();
    private FieldRefType() {
      addEnum(ID, "id");
      addEnum(PARENT_ID, "parentId");
      addEnum(CODE, "code");
      addEnum(ORDER, "order");
      addEnum(TITLE, "title");
      addEnum(REMARK, "remark");
      addEnum(PARENT_ID_LIST, "parentIdList");
      addEnum(TREE_LEVEL, "level");
      addEnum(CREATE_TIME, "createTime");
      addEnum(LAST_TIME, "lastTime");
      addEnum(SITE_ID, "siteId");
    }
  }

  // 字段外键类型
  final class FieldLookupType extends BiMapEnum.IntEnum {
    public static final FieldLookupType INSTANCE = new FieldLookupType();
    public static final int TABLE = INSTANCE.addEnum(1, "table");
    public static final int DICT = INSTANCE.addEnum(2, "dict");
    public static final int DATASET = INSTANCE.addEnum(3, "dataset");
  }
}
