package cc.smtweb.system.bpm.engine.ui.entity.yaml;

import lombok.Data;

import java.util.HashMap;
import java.util.Map;

@Data
public class YamlWidget {
  private String type;
  private String name;
  private YamlWidgetLayout layout;
  private Map<String, Object> props;
  private Map<String, String> events;
  private YamlWidget[] children;

  public void addProps(Map<String, Object> props) {
    this.props = new HashMap<>(props.size());
    // 深度对象应用的问题，不运行修改
    this.props.putAll(props);
  }

  public void addEvents(Map<String, String> events) {
    if (events != null) {
      this.events = new HashMap<>(events.size());
      this.events.putAll(events);
    }
  }
}
