package cc.smtweb.system.bpm.engine.ui.loader;

import cc.smtweb.system.bpm.engine.entity.AspModelTreeVO;
import cc.smtweb.system.bpm.util.CodeGenUtil;

import java.util.ArrayList;
import java.util.List;

public class TreePageRouter implements IPageRouter {
  private AspModelTreeVO root;
  private String moduleName;

  public TreePageRouter(AspModelTreeVO root, String moduleName) {
    this.root = root;
    this.moduleName = moduleName;
  }

  @Override
  public String loadFullName(Long pageId) {
    List<String> names = new ArrayList<>();

    if (getRouterName(pageId, root, names)) {
      if (moduleName != null) {
        names.add(0, moduleName);
      }

      return String.join(".", names);
    }

    return null;
  }

  private boolean getRouterName(Long pageId, AspModelTreeVO parent, List<String> names) {
    List<AspModelTreeVO> children = parent.getChildren();

    if (children != null) {
      for (AspModelTreeVO child: children) {
        if (pageId.equals(child.getModelId())) {
          names.add(CodeGenUtil.toLowerHump(child.getModelKey()));
          return true;
        } else {
          if (getRouterName(pageId, child, names)) {
            names.add(0, CodeGenUtil.toLowerHump(child.getModelKey()));
            return true;
          }
        }
      }
    }

    return false;
  }
}
