package cc.smtweb.system.bpm.engine.ui.loader;

import cc.smtweb.system.bpm.core.ui.entity.BpmPage;
import cc.smtweb.system.bpm.engine.AbstractLoader;
import cc.smtweb.system.bpm.engine.ui.loader.json.JsonPageDecoder;
import cc.smtweb.system.bpm.engine.ui.loader.yaml.YamlPageDecoder;
import lombok.extern.slf4j.Slf4j;

import java.io.InputStream;

@Slf4j
public abstract class UiPageLoader extends AbstractLoader<BpmPage> {
  private IPageRouter pageRouter;
  private int modelType;

  public UiPageLoader(IPageRouter pageRouter, int modelType) {
    this.pageRouter = pageRouter;
    this.modelType = modelType;
  }

  @Override
  public BpmPage load(String content) {
    JsonPageDecoder jsonPageDecoder = new JsonPageDecoder(this, pageRouter);

    BpmPage result = jsonPageDecoder.decode(content);
    if (result != null) {
      result.setModelType(modelType);
    }

    return  result;
  }

  public BpmPage load(InputStream is) {
    YamlPageDecoder yamlPageDecoder = new YamlPageDecoder();

    BpmPage result = yamlPageDecoder.decode(is);
    if (result != null) {
      result.setModelType(modelType);
    }

    return result;
  }
}

