package cc.smtweb.system.bpm.engine.ui.loader.json;

import cc.smtweb.system.bpm.core.ui.entity.dataset.BpmDataset;
import cc.smtweb.system.bpm.engine.ui.entity.vo.dataset.FzMasterMappingVO;
import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

@Getter
class SlaveDataset {
  private BpmDataset dataset;
  private String id;
  private String masterId;
  private FzMasterMappingVO masterMapping;

  public SlaveDataset(BpmDataset dataset, String id, String masterId, FzMasterMappingVO masterMapping) {
    this.dataset = dataset;
    this.id = id;
    this.masterId = masterId;
    if (StringUtils.isNotBlank(masterId) && masterMapping != null && masterMapping.getFields() != null) {
      this.masterMapping = masterMapping;
    }
  }

  public String getMasterId() {
    return masterId;
  }

  public boolean isSlave() {
    return masterMapping != null;
  }
}
