package cc.smtweb.system.bpm.engine.ui.loader.yaml;

import cc.smtweb.system.bpm.core.ui.entity.BpmPage;
import cc.smtweb.system.bpm.core.ui.entity.form.BpmForm;
import cc.smtweb.system.bpm.core.ui.entity.form.BpmWidget;
import cc.smtweb.system.bpm.core.ui.entity.form.BpmWidgetLayout;
import cc.smtweb.system.bpm.engine.ui.entity.yaml.*;
import cc.smtweb.system.bpm.util.YamlUtil;

import java.io.InputStream;
import java.util.List;

// TODO 关联信息的正确性检测
public class YamlPageDecoder {
  public YamlPageDecoder() {
  }

  public BpmPage decode(InputStream is) {
    YamlPage yamlPage = YamlUtil.readValue(is, YamlPage.class);

    BpmPage bpmPage = new BpmPage();
    bpmPage.setId(yamlPage.getId());
    bpmPage.setDestroyOnClose(yamlPage.getDestroyOnClose());

    List<YamlDataset> datasets = yamlPage.getDatasets();
    for (YamlDataset yamlDataset: datasets) {
      bpmPage.addDataset(YamlDatasetDecoder.decode(yamlDataset));
    }

    for (BpmForm form: bpmPage.getForms()) {
//      BpmForm form = bpmPage.getForm();
      YamlForm yamlForm = new YamlForm();
      decodeWidget(form ,yamlForm);
      yamlPage.getForms().add(yamlForm);
    }

    return bpmPage;
  }

  private void decodeWidget(BpmWidget bpmForm, YamlWidget yamlForm) {
    bpmForm.setType(yamlForm.getType());
    bpmForm.setName(yamlForm.getName());

    YamlWidgetLayout layout = yamlForm.getLayout();
    if (layout != null && layout.getCol() != null) {
      bpmForm.setLayout(new BpmWidgetLayout(layout.getCol()));
    }

    bpmForm.addProps(yamlForm.getProps());
    bpmForm.addEvents(yamlForm.getEvents());

    YamlWidget[] children = yamlForm.getChildren();
    if (children != null && children.length > 0) {
      BpmWidget[] bpmWidgets = new BpmWidget[children.length];
      for (int i = 0; i < children.length; i++) {
        BpmWidget bpmWidget = new BpmWidget();
        decodeWidget(bpmWidget, children[i]);
        bpmWidgets[i] = bpmWidget;
      }

      bpmForm.setChildren(bpmWidgets);
    }
  }
}
