package cc.smtweb.system.bpm.engine.ui.loader.yaml;

import cc.smtweb.system.bpm.core.ui.entity.form.BpmForm;
import cc.smtweb.system.bpm.core.ui.entity.form.BpmWidget;
import cc.smtweb.system.bpm.core.ui.entity.form.BpmWidgetLayout;
import cc.smtweb.system.bpm.engine.ui.entity.yaml.YamlForm;
import cc.smtweb.system.bpm.engine.ui.entity.yaml.YamlWidget;
import cc.smtweb.system.bpm.engine.ui.entity.yaml.YamlWidgetLayout;

public class YamlPageEncoder {
  public static YamlForm encode(BpmForm form) {
    YamlForm yamlForm  = new YamlForm();
    encodeWidget(yamlForm, form);

    return yamlForm;
  }

  private static void encodeWidget(YamlWidget yamlForm, BpmWidget bpmForm) {
    yamlForm.setType(bpmForm.getType());
    yamlForm.setName(bpmForm.getName());

    BpmWidgetLayout layout = bpmForm.getLayout();
    if (layout != null && layout.getCol() > 1) {
      YamlWidgetLayout yamlWidgetLayout = new YamlWidgetLayout();
      yamlWidgetLayout.setCol(layout.getCol());
      yamlForm.setLayout(yamlWidgetLayout);
    }

    yamlForm.addProps(bpmForm.getProps());
    yamlForm.addEvents(bpmForm.getEvents());

    BpmWidget[] children = bpmForm.getChildren();
    if (children != null && children.length > 0) {
      YamlWidget[] yamlWidgets = new YamlWidget[children.length];
      for (int i = 0; i < children.length; i++) {
        YamlWidget yamlWidget = new YamlWidget();
        encodeWidget(yamlWidget, children[i]);
        yamlWidgets[i] = yamlWidget;
      }

      yamlForm.setChildren(yamlWidgets);
    }
  }
}
