package cc.smtweb.system.bpm.spring;

import cc.smtweb.framework.core.SwMap;
import cc.smtweb.framework.core.mvc.config.ControllerConfig;
import cc.smtweb.framework.core.mvc.controller.binder.ParamEditor;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.bind.BpmBeanAttrEditor;
import cc.smtweb.system.bpm.core.ui.bind.BpmMapAttrEditor;
import cc.smtweb.system.bpm.core.ui.bind.BpmPageContextEditor;
import cc.smtweb.system.bpm.spring.action.BpmEventDao;
import cc.smtweb.system.bpm.spring.action.BpmEventLoader;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;

/**
 * @author kevin
 */
@Configuration
@ComponentScan
public class BpmAutoConfiguration {
  /** 配置自定义service扫描路径 {module}/{service}/{method} */
  @Bean
  public ControllerConfig bpmControllerConfig() {
    return new ControllerConfig("bpm", "cc.smtweb.system.bpm.web", (applicationContext, webDataBinder) -> {
      webDataBinder.bind(ParamEditor.TYPE_PARAM, BpmPageContext.class, new BpmPageContextEditor());
      webDataBinder.bind(ParamEditor.TYPE_ATTR, SwMap.class, new BpmMapAttrEditor());
      webDataBinder.bindDefault(ParamEditor.TYPE_ATTR, new BpmBeanAttrEditor());
      return new BpmEventLoader(applicationContext.getBean(BpmEventDao.class));
    });
  }
}
