package cc.smtweb.system.bpm.spring;

import cc.smtweb.system.bpm.engine.process.impl.entity.CommitTaskUserVO;
import cc.smtweb.system.bpm.engine.process.runtime.RouteInfo;
import cc.smtweb.system.bpm.engine.process.task.Task;
import cc.smtweb.system.bpm.engine.process.vo.FlowAction;
import cc.smtweb.system.bpm.engine.process.vo.FlowNode;
import cc.smtweb.system.bpm.engine.ui.IFormDataStore;

import java.util.List;

public interface IProcessEngine {
  /**
   * 新建任务，一般在流程开始时新建
   * @param flowId
   * @param  nodeKey
   * @return
   */
  Task newTask(long flowId, String nodeKey);

  /**
   * 保存任务数据
   * @param task
   * @return
   */
  Task saveTask(Task task);

//  void claim(long taskId, String userId);
//
//  void unclaim(String taskId);

  /**
   * 完成任务
   * @param task
   */
  void commitTask(Task task, FlowAction flowAction, List<CommitTaskUserVO> taskCommitInfo);

  void deleteTask(Task task);

  Task loadTask(long taskId);

  /** 提交路由 */
  RouteInfo routeCommit(Task task, FlowNode toFlowNode);

  /** 驳回路由 */
  RouteInfo routeReturn(Task task);

  IFormDataStore getFormDataStore();
}
