package cc.smtweb.system.bpm.spring.action;

import cc.smtweb.framework.core.mvc.controller.IActionManager;
import cc.smtweb.framework.core.mvc.controller.access.IMethodAccess;
import cc.smtweb.framework.core.mvc.controller.scan.IScanAction;
import cc.smtweb.system.bpm.core.annotation.BpmEvent;

public class BpmEventLoader implements IScanAction<BpmEvent> {
  private BpmEventDao bpmEventDao;

  public BpmEventLoader(BpmEventDao bpmActionService) {
    this.bpmEventDao = bpmActionService;
  }

  @Override
  public Class<BpmEvent> actionType() {
    return BpmEvent.class;
  }

  @Override
  public void load(IActionManager apiManager, String module, BpmEvent webAction, IMethodAccess methodAccess) {
//    WebMethodAccess webMethodAccess = new WebMethodAccess(methodAccess);
//    apiManager.api("web/webAction", webMethodAccess);
    // 给 bpmActionService 添加数据集扩展实现，先判断是否有重复
    bpmEventDao.addAction(webAction, methodAccess);
  }
}
