package cc.smtweb.system.bpm.web.design.codegen;

import cc.smtweb.framework.core.annotation.SwParam;
import cc.smtweb.framework.core.db.DbEngine;
import cc.smtweb.system.bpm.engine.entity.AspModelTreeVO;
import cc.smtweb.system.bpm.spring.dao.DatasetConfigDao;
import cc.smtweb.system.bpm.util.ITreeDataLevelHandler;
import cc.smtweb.system.bpm.util.TreeDataUtil;

import java.util.List;

public abstract class AbstractCodeService {
  @SwParam
  protected DbEngine dbEngine;

  @SwParam
  protected DatasetConfigDao datasetConfigDao;

  protected AspModelTreeVO loadParentPage(Long pageId) {
    List<AspModelTreeVO> list = dbEngine.query("select model_id, model_parent_id, model_key, model_name from sw_bpm.asp_model where model_mc_id in" +
                    " (select model_mc_id from sw_bpm.asp_model where model_id=?)",
            AspModelTreeVO.class, pageId);
    AspModelTreeVO root = new AspModelTreeVO();
    ITreeDataLevelHandler<AspModelTreeVO> handler = AspModelTreeVO.createTreeHandler();
    TreeDataUtil.buildLevelTree(root, list, handler);
    return TreeDataUtil.findParent(root, pageId, 1, handler);
  }
}
