package cc.smtweb.system.bpm.web.design.codegen;

import cc.smtweb.framework.core.R;
import cc.smtweb.framework.core.SwMap;
import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.annotation.SwParam;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.file.FilePathGenerator;
import cc.smtweb.system.bpm.spring.BpmConfigBean;
import cc.smtweb.system.bpm.util.YamlUtil;
import lombok.extern.slf4j.Slf4j;

import java.io.File;
import java.io.IOException;

// 控件配置代码后台生成
@Slf4j
@SwService
public class WidgetCodeService extends AbstractCodeService {
  @SwParam
  private FilePathGenerator filePathGenerator;

  @SwParam
  private BpmConfigBean bpmConfigBean;

  /** 生成代码 */
  public R build(@SwParam("type") String type, @SwBody SwMap body) throws IOException {
    // 资源文件路径
    String codeJavaPath = bpmConfigBean.getCodeJavaPath();
    String resourceRootPath = codeJavaPath.substring(0, codeJavaPath.length() - JavaCodeService.SRC_MAIN_JAVA.length())
      + JavaCodeService.SRC_MAIN_RES + "/bpm/ui/";
    File file = new File(resourceRootPath + type + ".yaml");
    if (file.exists()) {
      return R.success();
    }

    YamlUtil.writeValue(file, body);
    return R.success(file.getAbsolutePath());
  }
}
