package cc.smtweb.system.bpm.web.design.table;

import cc.smtweb.framework.core.common.SwConsts;
import cc.smtweb.framework.core.db.vo.ModelCatalog;
import cc.smtweb.framework.core.mvc.service.TreeHelper;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Comparator;
import java.util.List;

/**
 * Created by Akmm at 2022/3/25 10:47
 */
public class ModelCatalogTreeHelper extends TreeHelper<ModelCatalog> {
    //按项目的缓存key，确保此表缓存配置：prj：prjid_parentid
    private final static String CACHE_KEY = "prj";

    public ModelCatalogTreeHelper() {
        super(ModelCatalog.ENTITY_NAME);
    }

    public List<ModelCatalog> getChildren(long id, long prj_id, Comparator<ModelCatalog> comparator) {
        if (id > 0) {
            return getChildren(id, comparator);
        }
        Collection<ModelCatalog> set = cache.getListByKey(CACHE_KEY, prj_id + SwConsts.SPLIT_CHAR + SwConsts.DEF_ROOT_ID);

        List<ModelCatalog> list = set == null ? new ArrayList<>() : new ArrayList<>(set);
        if (comparator != null)
            list.sort(comparator);
        return list;
    }
}
