package cc.smtweb.system.bpm.web.ui;

import cc.smtweb.framework.core.R;
import cc.smtweb.framework.core.annotation.SwParam;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.service.card.AbstractDatasetCardService;
import cc.smtweb.system.bpm.core.ui.service.list.AbstractDatasetListService;
import cc.smtweb.system.bpm.core.ui.service.tree.AbstractDatasetTreeService;
import cc.smtweb.system.bpm.spring.action.BpmEventDao;

/**
 * 动态界面数据服务
 * @author xkliu
 */
@SwService
public class DatasetService {
  @SwParam
  private BpmEventDao bpmEventDao;

  public R load(BpmPageContext pageContext) {
    AbstractDatasetCardService cardService = bpmEventDao.getCardService(pageContext);
    return cardService.load(pageContext);
  }

  public R save(BpmPageContext pageContext) {
    AbstractDatasetCardService cardService = bpmEventDao.getCardService(pageContext);
    return cardService.save(pageContext);
  }

  public R remove(BpmPageContext pageContext) {
    AbstractDatasetCardService cardService = bpmEventDao.getCardService(pageContext);
    return cardService.remove(pageContext);
  }

  public R list(BpmPageContext pageContext) {
    AbstractDatasetListService listService = bpmEventDao.getListService(pageContext);
    return listService.list(pageContext);
  }

  public R count(BpmPageContext pageContext) {
    AbstractDatasetListService listService = bpmEventDao.getListService(pageContext);
    return listService.count(pageContext);
  }

  public R listAll(BpmPageContext pageContext) {
    AbstractDatasetListService listService = bpmEventDao.getListService(pageContext);
    return listService.listAll(pageContext);
  }

  public R treeAll(BpmPageContext pageContext) {
    AbstractDatasetTreeService treeService = bpmEventDao.getTreeService(pageContext);
    return treeService.treeAll(pageContext);
  }

  public R move(BpmPageContext pageContext) {
    AbstractDatasetTreeService treeService = bpmEventDao.getTreeService(pageContext);
    return treeService.move(pageContext);
  }
}
