package cc.smtweb.system.bpm.web.ui.dynform;

import cc.smtweb.framework.core.annotation.SwParam;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.service.card.AbstractDatasetCardService;
import cc.smtweb.system.bpm.core.ui.service.card.DatasetCardWorker;
import cc.smtweb.system.bpm.spring.dao.DatasetCardDao;
import cc.smtweb.system.bpm.web.ui.dao.JsonDatasetCardDao;

/**
 * 动态界面Card数据服务
 * @author xkliu
 */
@SwService
public class DynFormCardService extends AbstractDatasetCardService {
  @SwParam
  private DatasetCardDao datasetCardDao;

  @SwParam
  private JsonDatasetCardDao jsonDatasetCardDao;

  @Override
  protected DatasetCardWorker createCardLoadHandler(BpmPageContext pageContext) {
    DatasetCardWorker handler = new DatasetCardWorker(pageContext);
    if (handler.getPageContext().isDeploy()) {
      handler.handleLoad(datasetCardDao::load);
      handler.handleLoadLookup(datasetCardDao::loadLookup);
    } else {
      handler.handleLoad(jsonDatasetCardDao::load);
      handler.handleLoadLookup(jsonDatasetCardDao::loadLookup);
    }

    return handler;
  }

  @Override
  protected DatasetCardWorker createCardSaveHandler(BpmPageContext pageContext) {
    DatasetCardWorker handler = new DatasetCardWorker(pageContext);
    if (handler.getPageContext().isDeploy()) {
      handler.handleSave(datasetCardDao::save);
    } else {
      handler.handleSave(jsonDatasetCardDao::save);
    }

    return handler;
  }

  @Override
  protected DatasetCardWorker createCardRemoveHandler(BpmPageContext pageContext) {
    DatasetCardWorker handler = new DatasetCardWorker(pageContext);
    if (handler.getPageContext().isDeploy()) {
      handler.handleRemove(datasetCardDao::remove);
    } else {
      handler.handleRemove(jsonDatasetCardDao::remove);
    }

    return handler;
  }
}
