package cc.smtweb.system.bpm.web.ui.dynform;

import cc.smtweb.framework.core.annotation.SwParam;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.service.list.AbstractDatasetListService;
import cc.smtweb.system.bpm.core.ui.service.list.DatasetListWorker;
import cc.smtweb.system.bpm.spring.dao.DatasetListDao;
import cc.smtweb.system.bpm.web.ui.dao.JsonDatasetListDao;

@SwService
public class DynFormListService extends AbstractDatasetListService {
  @SwParam
  private DatasetListDao datasetListDao;

  @SwParam
  private JsonDatasetListDao jsonDatasetListDao;

  @Override
  protected DatasetListWorker createListPartHandler(BpmPageContext pageContext) {
    DatasetListWorker handler = new DatasetListWorker(pageContext);
    handler.handleListLookup(datasetListDao::listLookup);

    if (handler.getPageContext().isDeploy()) {
      handler.handleListPart(datasetListDao::list);
      handler.handleCount(datasetListDao::count);
    } else {
      handler.handleListPart(jsonDatasetListDao::list);
      handler.handleCount(jsonDatasetListDao::count);
    }

    return handler;
  }

  @Override
  protected DatasetListWorker createListAllHandler(BpmPageContext pageContext) {
    DatasetListWorker handler = new DatasetListWorker(pageContext);
    handler.handleListLookup(datasetListDao::listLookup);

    if (handler.getPageContext().isDeploy()) {
      handler.handleListAll(datasetListDao::listAll);
    } else {
      handler.handleListAll(jsonDatasetListDao::listAll);
    }


    return handler;
  }
}
