package cc.smtweb.system.bpm.web.ui.dynform;

import cc.smtweb.framework.core.annotation.SwParam;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.service.tree.AbstractDatasetTreeService;
import cc.smtweb.system.bpm.core.ui.service.tree.DatasetTreeWorker;
import cc.smtweb.system.bpm.spring.dao.DatasetTreeDao;

@SwService
public class DynFormTreeService extends AbstractDatasetTreeService {
  @SwParam
  private DatasetTreeDao datasetTreeDao;

  @SwParam
  private DatasetTreeDao jsonDatasetTreeDao;

  @Override
  protected DatasetTreeWorker createTreeAllHandler(BpmPageContext pageContext) {
    DatasetTreeWorker handler = new DatasetTreeWorker(pageContext);
    if (handler.getPageContext().isDeploy()) {
      handler.handleTreeAll(datasetTreeDao::treeAll);
    } else {
      handler.handleTreeAll(jsonDatasetTreeDao::treeAll);
    }

    return handler;
  }

  @Override
  protected DatasetTreeWorker createTreeMoveHandler(BpmPageContext pageContext) {
    DatasetTreeWorker handler = new DatasetTreeWorker(pageContext);
    if (handler.getPageContext().isDeploy()) {
      handler.handleMove(datasetTreeDao::move);
    } else {
      handler.handleMove(jsonDatasetTreeDao::move);
    }

    return handler;
  }
}
