package cc.smtweb.system.bpm.test;

import cc.smtweb.system.bpm.util.CodeGenUtil;
import org.apache.commons.lang3.StringUtils;
import org.junit.Test;

/**
 * Created by Akmm at 2022/3/1 9:41
 * 生成bean
 */
public class BuildJavaBean {
    @Test
    public void buildBean() {
        String str = "`db_id` bigint(20) NOT NULL,\n" +
                "  `db_prj_id` bigint(20) DEFAULT NULL,\n" +
                "  `db_name` varchar(64) COLLATE utf8_unicode_ci DEFAULT NULL COMMENT '添加上所有父节节点key，就构成模型唯一key',\n" +
                "  `db_title` varchar(200) COLLATE utf8_unicode_ci NOT NULL COMMENT '名称',\n" +
                "  `db_status` tinyint(4) NOT NULL DEFAULT '0' COMMENT '状态：0 启用，1 禁用',\n" +
                "  `db_version` int(11) NOT NULL DEFAULT '0' COMMENT '版本',\n" +
                "  `db_create_uid` bigint(20) DEFAULT NULL,\n" +
                "  `db_update_uid` bigint(20) DEFAULT NULL,\n" +
                "  `db_create_at` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间',\n" +
                "  `db_update_at` bigint(20) NOT NULL DEFAULT '0' COMMENT '更新时间',\n";
        String[] ss = str.split("\n");
        for (String s: ss) {
            String[] s0 = s.trim().split(" ");
            if (StringUtils.isEmpty(s0[0])) continue;
            String tn = s0[0].substring(1, s0[0].indexOf("`", 2));
            String tnu = CodeGenUtil.underlineToUpperHump(tn.substring(tn.indexOf("_") + 1));
            String tnn = CodeGenUtil.underlineToHump(tn);

            String tt = s0[1];
            String ttj;
            if (tt.contains("(")) tt = tt.substring(0, tt.indexOf("("));
            switch (tt) {
                case "bigint":
                    tt = "long";
                    ttj = "Long";
                    break;
                case "tinyint":
                    case "int":
                    tt = "int";
                    ttj = "Int";
                    break;
                default:
                    tt = "String";
                    ttj = "Str";
                    break;
            }
            System.out.println("public " + tt + " get" + tnu + "(){\n" +
                    "return get" + ttj + "(\"" + tn + "\");\n" +
                    "}\n" +
                    "" +
                    "public void set" + tnu + "(" + tt + " " + tnn + "){\n" +
                    "put(\"" + tn + "\", " + tnn + ");\n" +
                    "}\n");
        }
    }
}
