package cc.smtweb.system.bpm.test.codegen.test;

import java.io.*;
import java.nio.charset.StandardCharsets;

public class FileUtils {
  /**
   * 获取文件的行
   *
   * @param fileName
   *            文件名称
   * @return List<String>
   */
  public static String readFile(String fileName) {
    StringBuilder lines = new StringBuilder();
    InputStreamReader read = null;
    BufferedReader bufferedReader = null;
    try {
      String configPath = FileUtils.class.getResource(fileName).getPath();
      configPath = configPath.replaceAll("%20", " ");// 处理文件路径中空格问题
      File file = new File(configPath);
      if (file.isFile() && file.exists()) { // 判断文件是否存在
        read = new InputStreamReader(new FileInputStream(file), StandardCharsets.UTF_8);
        bufferedReader = new BufferedReader(read);
        String lineTxt;
        while ((lineTxt = bufferedReader.readLine()) != null) {
          if (lineTxt.length() == 0) {
            continue;
          }
          lines.append(lineTxt);
        }
      }
    } catch (Exception e) {
      e.printStackTrace();
    } finally {
      try {
        if (read != null) {
          read.close();
        }
      } catch (IOException e) {
        e.printStackTrace();
      } finally {
        if (bufferedReader != null) {
          try {
            bufferedReader.close();
          } catch (IOException e) {
            e.printStackTrace();
          }
        }
      }
    }
    return lines.toString();
  }
}

