package cc.smtweb.system.bpm.test.codegen.test;

import cc.smtweb.framework.core.util.JsonUtil;
import cc.smtweb.system.bpm.util.YamlUtil;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.HashMap;

public class YamlToJsonTest {
  public static void main(String[] args) throws Exception {
    File dir = new File("/var/config/");

    for (File file: dir.listFiles()) {
      if (file.getName().endsWith(".yaml")) {
        try (FileInputStream is = new FileInputStream(file)) {
          HashMap map = YamlUtil.readValue(is, HashMap.class);
          String name = (String)map.get("name");
          if (StringUtils.isNotBlank(name)) {
            String json = "export default " + JsonUtil.encodeString(map);
            try (OutputStream writer = new FileOutputStream("/var/config/json/" + name + ".ts")) {
              IOUtils.write(json, writer, "utf8");
            }
            System.out.println(name);
          }
        }
      }
    }
  }
}
